
options = { 
    name = "EA_PLM",
    handler = EA_PLM,
    type = "group",
    args = {
		thank_msg = {
			order = 1,
			type = "description",
			name = "      " .. L["THX_MSG_AUTH"] .. ":                   Dochine @ EU-Les Sentinelles" .. "\n" .. "      " .. L["THX_MSG_THX"] .. ":        Kartøff-LesSentinelles, Maully-ConfrérieduThorium, Zeriane-LesClairvoyants",
		},
		showGeneral = {
            type = "group",
            name = "General",
            dialogInline = true,
            order = 2,
            args = {
				perso = {
					order = 1,
					type = "toggle",
					name = L["OPT_RL_MODE"],
					width = "full",
					tristate = false,
					get = function(info) return Config[PLM_CONF_RL_MODE] end,
					set = function(info, s) if s == nil then s = false end; Config[PLM_CONF_RL_MODE] = s end,
				},
				includeXmog = {
					order = 2,
					type = "toggle",
					name = L["OPT_INCLUDE_XMOG"],
					--width = "full",
					tristate = false,
					get = function(info) return Config[PLM_INCLUDE_XMOG] end,
					set = function(info, s) if s == nil then s = false end; Config[PLM_INCLUDE_XMOG] = s end,
				},
				evenNoUp = {
					order = 2,
					type = "toggle",
					name = L["OPT_XMOG_UP"],
					width = "double",
					tristate = false,
					get = function(info) options.args.showGeneral.args.evenNoUp.tristate = Config[PLM_XMOG_UP]; return Config[PLM_XMOG_UP] end,
					set = function(info, s) if s == nil then s = false end; Config[PLM_XMOG_UP] = s end,
					disabled = function(info) return not Config[PLM_INCLUDE_XMOG] end,
				},
				usepawnscore = {
					order = 3,
					type = "toggle",
					name = L["OPT_PAWN_SCORE"],
					width = "full",
					tristate = false,
					get = function(info) options.args.showGeneral.args.usepawnscore.tristate = Config[PLM_CONF_USE_SW_SCORE]; return Config[PLM_CONF_USE_SW_SCORE] end,
					set = function(info, s) if s == nil then s = false end; Config[PLM_CONF_USE_SW_SCORE] = s; if s == true then options.args.showGeneral.args.statScale.disabled = false else options.args.showGeneral.args.statScale.disabled = true end end,
				},
				statScale = {
					order = 4,
					type = "input",
					name = L["OPT_STAT_WEIGHT"],
					width = "full",
					disabled = function(info) return not options.args.showGeneral.args.usepawnscore.tristate end,
					get = function(info) if Config[PLM_STAT_WEIGHTS] == nil then return "" end; return Config[PLM_STAT_WEIGHTS] end,
					set = function(info, s) Config[PLM_STAT_WEIGHTS] = s; Config[PLM_SCALE_VALUE] = parsePawnString(Config[PLM_STAT_WEIGHTS]) end, --print("stat scale:", dump(Config[PLM_SCALE_VALUE]))
				},
				promptChat = {
					order = 5,
					type = "select",
					name = L["OPT_ANNOUNCE_CHAT"],
					width = "full",
					values = {
						[PLM_CHAT_ALWAYS] = L["OPT_CHAT_ALWAYS"],
						[PLM_CHAT_IFRL] = L["OPT_CHAT_IFRL"],
						[PLM_CHAT_NEVER] = L["OPT_CHAT_NEVER"],
					},
					style = "radio",
					get = function(info) return Config[PLM_PROMPT_CHAT] end,
					set = function(info, s) Config[PLM_PROMPT_CHAT] = s end,
				},
				chat_delay = {
					order = 6,
					type = "range",
					name = L["OPT_CHAT_DELAY"],
					width = "double",
					min = 0,
					max = 10,
					softMin = 0,
					softMax = 10,
					step = 1,
					get = function(info) return Config[PLM_DELAY_CHAT] end,
					set = function(info, s) Config[PLM_DELAY_CHAT] = s end,
				},
				threshold = {
					order = 7,
					type = "range",
					name = L["OPT_ILVL_THRESHOLD"],
					width = "double",
					min = -25,
					max = 0,
					softMin = -25,
					softMax = 0,
					step = 5,
					get = function(info) return Config[PLM_ILVL_THRESHOLD] + 1 end,
					set = function(info, s) Config[PLM_ILVL_THRESHOLD] = s - 1 end,
				},
				wisp_msg = {
					order = 8,
					type = "input",
					name = L["OPT_WISP_MSG"],
					width = "full",
					get = function(info) return Config[PLM_WISP_MSG] end,
					set = function(info, s) if (s == "") then Config[PLM_WISP_MSG] = L["OPT_WISP_EXAMPLE"] else Config[PLM_WISP_MSG] = s end end,
				},
			},
        },
		plmuser = {
            type = "group",
            name = L["OPT_OTHER_USER"],
            dialogInline = true,
            order = 3,
            args = {
				update = {
					order = 1,
					type = "execute",
					name = L["OPT_UPDATE"],
					width = "double",
					func = "request_plm_user",
				},
				show_users = {
					order = 2,
					type = "description",
					fontSize = "medium",
					name = "",
				},
			},
        },

		
				
				
		--[[showTest = {
            type = "group",
            name = "Test  TOUCHE PAS A CA OMG",
            dialogInline = true,
            order = 3,
            args = {
				force_refresh = {
					order = 1,
					type = "execute",
					name = "force cache",
					width = "full",
					func = "PopulateGroupInfoCache",

				},
				test = {
					order = 2,
					type = "execute",
					name = "test self",
					width = "full",
					func = "test_func",

				},
				test1 = {
					order = 3,
					type = "execute",
					name = "test other",
					width = "full",
					func = "test_func1",
				},
				testmsg = {
					order = 4,
					type = "execute",
					name = "test msg",
					width = "full",
					func = "SendAddonMsg_request",
				},
				testreceiv = {
					order = 4,
					type = "execute",
					name = "test rec",
					width = "full",
					func = function(info) EA_PLM:GetMsgAddon(self, nil, "EAPLM", "test\ttest", "RAID", PLM_GetFullName('player')) end,
				},
			},
        },]]--
    },
}
				
				
function dump(o)
   if type(o) == 'table' then
      local s = '{ '
      for k,v in pairs(o) do
         if type(k) ~= 'number' then k = '"'..k..'"' end
         s = s .. '['..k..'] = ' .. dump(v) .. ','
      end
      return s .. '} '
   else
      return tostring(o)
   end
end

function EA_PLM:request_plm_user()
	plmUsers = {}
	if IsInRaid() then
		for i=1,GetNumGroupMembers() do
			local name = GetRaidRosterInfo(i)
			if name then
				plmUsers[PLM_GetFullName(name)] = "..."
			end
		end
	else
		for _,unit in pairs({"party1","party2","party3","party4","player"}) do
			local name,realm = UnitName(unit)
			if name then
				plmUsers[PLM_GetFullName(name)] = "..."
			end
		end
	end
	str = "\n"
	for username, v in pairs(plmUsers) do
		local localizedClass, englishClass, classIndex = UnitClass(username)
		if englishClass ~= nil then
			str = str .. "   |c" .. RAID_CLASS_COLORS[englishClass].colorStr .. username .. "|r"
		else
			localizedClass, englishClass, classIndex = UnitClass('player')
			str = str .. "   |c" .. RAID_CLASS_COLORS[englishClass].colorStr .. username .. "|r"
		end

		str = str.."   ...\n"
	end
	
	options.args.plmuser.args.show_users.name = str
	plmUsers[PLM_GetFullName('player')] = GetAddOnMetadata("EA_PLM", "Version")
	EA_PLM:SendAddonMsg_request()
	C_Timer.After(2, function() EA_PLM:update_plmusers() end)
end


function EA_PLM:update_plmusers()
	
	up_to_date_version = 0
	for username, v in pairs(plmUsers) do
		if (v ~= "...") then
			ver = tonumber(string.sub(v, 2))
			if (ver > up_to_date_version) then
				up_to_date_version = ver
			end
		end
	end
	
	
	new = "\n"
	for username, v in pairs(plmUsers) do
		local localizedClass, englishClass, classIndex = UnitClass(username)
		if englishClass ~= nil then
			new = new .. "   |c" .. RAID_CLASS_COLORS[englishClass].colorStr .. username .. "|r"
		else
			localizedClass, englishClass, classIndex = UnitClass('player')
			new = new .. "   |c" .. RAID_CLASS_COLORS[englishClass].colorStr .. username .. "|r"
		end
		
		new = new.." -------- "
		
		if (v ~= "...") then
			ver = tonumber(string.sub(v, 2))
			if (ver == up_to_date_version) then
				new = new .. "|cFF00FF00" .. v .. "|r" .. "\n"
			else
				new = new .. "|cFFFFFF00" .. v .. "|r" .. "\n"
			end
		else
			new = new .. "|cFFFF0000" .. "no addon" .. "|r" .. "\n"
		end
	end
	options.args.plmuser.args.show_users.name = new

	InterfaceOptionsFrame_OpenToCategory(options.name)
end


function EA_PLM:SendAddonMsg_request()
	addonPrefix = "EAPLM"
	prefix = "request_version"
	msg = ""
	C_ChatInfo.SendAddonMessage(addonPrefix, prefix .. "\t" .. msg, "RAID")
end

function EA_PLM:GetMsgAddon(self, event, ...)
	prefix, message, channel, sender = ...
	if prefix == "EAPLM" then
		tmp = split(message, '\t')
		if (tmp[1] == "request_version") then
			addonPrefix = "EAPLM"
			prefix = "response_version"
			msg = GetAddOnMetadata("EA_PLM", "Version")
			C_ChatInfo.SendAddonMessage(addonPrefix, prefix .. "\t" .. msg, "RAID")
		elseif (tmp[1] == "response_version") then
			plmUsers[PLM_GetFullName(sender)] = tmp[2]
		end
	end
end










function EA_PLM:test_func()
	--lootedItemsFrame:Show()
	
	--local PLM_TEST_ITEM_1 = '\124cffa335ee\124Hitem:160719:::::::::\124h[Visage du prophète sublimé]\124h\124r'
	local PLM_TEST_ITEM_1 = "\124cffa335ee\124Hitem:160644::::::::120::::2:1507:4799:\124h[Grande cape dégoulinante de plasma]\124h\124r"
	
	--print(PLM_TEST_ITEM_1); 

	PLM_TEST_ITEM_1 = select(2, GetItemInfo(PLM_TEST_ITEM_1))

	--print(PLM_TEST_ITEM_1); 
	local playerName = PLM_GetFullName('player')
	--local playerName = 'Maully-ConfrérieduThorium'
	
	--local msg = 'Maully-ConfrérieduThorium reçoit le butin : '..PLM_TEST_ITEM_1..'. '
	local msg = 'Vous recevez le butin : '..PLM_TEST_ITEM_1..'. '
	--print(msg); 
	EA_PLM:LootReceivedEvent(self, nil, msg, nil, nil, nil, playerName)
	
end

function EA_PLM:test_func1()

	--lootedItemsFrame:Show()
	
	--local PLM_TEST_ITEM_1 = '\124cffa335ee\124Hitem:160719:::::::::\124h[Visage du prophète sublimé]\124h\124r'
	local PLM_TEST_ITEM_1 = "\124cffa335ee\124Hitem:160644::::::::120::::2:1507:4799:\124h[Grande cape dégoulinante de plasma]\124h\124r"

	--print(PLM_TEST_ITEM_1); 

	PLM_TEST_ITEM_1 = select(2, GetItemInfo(PLM_TEST_ITEM_1))

	--print(PLM_TEST_ITEM_1); 
	--local playerName = PLM_GetFullName('player')
	local playerName = 'Zeriane-LesClairvoyants'
	
	local msg = 'Zeriane-LesClairvoyants reçoit le butin : '..PLM_TEST_ITEM_1..'. '
	--local msg = 'Vous recevez le butin : '..PLM_TEST_ITEM_1..'. '
	--print(msg); 
	EA_PLM:LootReceivedEvent(self, nil, msg, nil, nil, nil, playerName)
	--EA_PLM:AddLootedItem(EA_PLM:GetFullItemInfo(PLM_TEST_ITEM_1), playerName, STATUS_RL_LOOT)
end

